﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace("AspNetAjaxPreview");

AspNetAjaxPreview.InPlaceEditBehavior = function(element) {
    AspNetAjaxPreview.InPlaceEditBehavior.initializeBase(this, [element]);
}

AspNetAjaxPreview.InPlaceEditBehavior.prototype = {
    initialize: function() {
        AspNetAjaxPreview.InPlaceEditBehavior.callBaseMethod(this, 'initialize');

        var element = this.get_element();
        $addHandler(element, "click", this._clickHandler = Function.createDelegate(this, function(e) {
            if (element.InPlaceEditBehavior.expanded) {
                return;
            }
            element.InPlaceEditBehavior.expanded = true;
            var input = document.createElement("input");
            input.type = "text";
            if (element.id) {
                input.id = element.id + "_input";
            }
            $addHandler(input, "blur", this._inputBlurHandler = Function.createDelegate(this, function(e) {
                var newValue = element.innerHTML = input.value;
                element.InPlaceEditBehavior.expanded = false;
                $removeHandler(input, "blur", this._inputBlurHandler);
                if (newValue != oldValue) {
                    this.raiseChanged();
                }
            }));
            var oldValue = input.value = element.innerHTML;
            element.innerHTML = "";
            input.style.width = element.offsetWidth - 10;
            element.appendChild(input);
            input.focus();
        }));
    },
    add_changed: function(handler) {
        this.get_events().addHandler("changed", handler);
    },
    remove_changed: function(handler) {
        this.get_events().removeHandler("changed", handler);
    },
    raiseChanged: function() {
        var handlers = this.get_events().getHandler("changed"); if (handlers) {
            handlers(this, Sys.EventArgs.Empty);
        }
    },
    dispose: function() {
        var element = this.get_element();
        $removeHandler(element, "click", this._clickHandler);

        AspNetAjaxPreview.InPlaceEditBehavior.callBaseMethod(this, 'dispose');
    }
}
AspNetAjaxPreview.InPlaceEditBehavior.registerClass('AspNetAjaxPreview.InPlaceEditBehavior', Sys.UI.Behavior);

if (typeof(Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
